## @file Snake_2.o.py
#  @author Andy Hameed, Usman Irfan
#  @brief implements gameplay and connects the different components of the game
#  @date 11/09/2018


from random import randint
from Snake import *
from init import *

# One size for all blocks created for snake
size = 20 

#velocity and score
vel = 10
score = 0

#initial x and y coordinates of the snake
x = randint(0,screenSize - size)
y = randint(0, screenSize - size)

speed = 40

# 0 gives (- direction)
# 1 gives (+ direction)
direction = 0
# 0 - x-axis , 1 - y-axis
axis = 0

location = []

food_x = randint(0,screenSize - size)
food_y = randint(0,screenSize - size)
location = [food_x, food_y]

##initialize snake
snake = Snake(size, 0, 20, 0)

#Loop through the events as long as the game is running
run = True 
while run:
    pygame.time.delay(speed) #create a delay to prevent any unwanted behaviour

    #events are anything that happens from the user
    #we loop through the list of events that happen by the user's actions
    for event in pygame.event.get():

        #Check if the event is a quit command and quit the game if it is
        if event.type == pygame.QUIT:
            run = False

        #Each event type has an integer assigned to it. KEYDOWN has the code 2
        if event.type == pygame.KEYDOWN:
            if (event.key == pygame.K_LEFT):
                    snake.axis = 0; snake.direct = -1
            if (event.key == pygame.K_RIGHT):
                    snake.axis = 0; snake.direct = 1
            if (event.key == pygame.K_UP):
                    snake.axis = 1; snake.direct = -1
            if (event.key == pygame.K_DOWN):
                    snake.axis = 1 ; snake.direct = 1

    #Snake moving depending on axis and direction
    if (snake.axis):
        y += vel*snake.direct
    else:
        x += vel*snake.direct

    #Boundary conditions for snake hitting window edge
    if x < 0:
        #x = 0
        x = screenSize - size
    if y < 0:
        #y = 0
        y = screenSize - size
    if y > screenSize - size:
        #y = 500 - size
        y = 0
    if x > screenSize - size:
        #x = 500 - size
        x = 0


    #all colors are defined in RGB with Pygame
    #consumption of food block
    if( abs(x - food_x) < 15 and abs(y - food_y) < 15):
        score += 1
        food_x = randint(0,screenSize - size)
        food_y = randint(0,screenSize - size)
        location = [food_x, food_y]
        print('score = ', score)
        
        ## --------------------------DELETE --------------------------
        #extend length or size depending on the direction of the snake
##        if (axis):
##            size += 20
##        else:
##            size += 20
        ##---------------------------DELETE----------------------------
         
        
        
        
    win.fill(white)

    #Draw food item
    pygame.draw.rect(win,blue, (location[0], location[1], size, size))

    #Draw snake
    snake.draw(x,y)
    
            
    #we have to update the display to see the drawing of our object. Since it does
    #not automatically update
    pygame.display.update()

#Quit the game
pygame.quit()
